;/*
cc -o qfaxClient qfaxClient.c jcall.s -lmin -lCSM
quit
*/

/*
 * qfaxClient. A simple demo of qfax client/server usage.
 * Requires jcall.o from c68 libqptr examples disk
 *
 * Freely distributable without restriction, other than commercial sale
 * (c) Jonathan Hudson June 1994.
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <qdos.h>
#include <qptr.h>
#include <stdarg.h>
#include <string.h>
#include <pd/csrvthg.h>

#define F3KEY   0xf0

extern struct WM_sprite wm_sprite_move, wm_sprite_f3;
static long lit_reset (struct WM_wwork *, short);
static long ACMD (struct WM_wwork *, struct WM_litm *);
static long MMOVE (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);
static long AEXIT (struct WM_wwork *, struct WM_litm *);

static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static struct WM_action acmd = {JSR, wm_actli, ACMD};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork               point back to work def */
    NULL,			/* *wdef                this was wdef */
    0,				/* chid                 chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,			/* kstk, kprs           key stroke and press */
    0,				/* evnt                 event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare       window mode and spare */
    NULL,			/* *ciact               current item "action" */
    -1,				/* citem                current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40]            loose item status */
};

#define ninfw    4		/* number of information windows */
#define ninfo    1		/* number of information objects */
#define nlitm    3		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

#define min_wid     264
#define min_hgt     86

static QD_TEXTI (END, "ESC");
static QD_TEXTI (TITLE, "qfax Client");
char _prog_name[] =  "qfax Client";

static struct WM_info info[ninfo + 1] =
{
    {72, 10, 3, 0, 0, 0, {2, 0, 0}, &TITLE},
    {-1}
};

static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {438, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 7, 84,			/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {78, 12,			/* xsize, ysize         size */
     184, 1,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     info},			/* *pobj                pointer to object list */
    {422, 12,			/* xsize, ysize         size */
     16, 14,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {16, 12,			/* xsize, ysize         size */
     0, 14,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
     {-1}			/* end of array */
};

static struct WM_litm litm[nlitm + 1] =		/* loose item */
{
    {22, 10,   2, 2, 0, 0, 2, K_MOVE,   &wm_sprite_move,    0, &mmove},
    {22, 10, 410, 2, 0, 0, 0, K_CANCEL, &END,               1, &aexit},
    {10, 10,   3,15, 2, 0, 2, F3KEY,    &wm_sprite_f3,      2, &acmd},
    {-1}
};

static struct WM_appw aw0 =	/* application sub-window */
{
    438, 20,			/* xsize, ysize         size */
    0, 27,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    1, 4, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    NULL,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    4, 2, 7,			/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    0, 2, 7			/* psac, psbc, pssc arrow/bar clrs */
};

static struct WM_appl appl[nappl + 1] = {&aw0, NULL};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst               pointer to sprite list */
    438, 48,			/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    NO_WCLEAR, 			/* flag                 no clear + shadow */
    1, 4, 7,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};

static int ChanId;
static int pid   = -1;

extern jcall (void (*)(), char *, int, int, int,...);

char *stpcpy (char *d, const char *s)
{
    while (*d++ = *s++) ;
    return (d - 1);
}

static long lit_reset (struct WM_wwork *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;
    return wm_ldraw (wwk, -1);
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    return PT__CAN;
}

static int repchn = 0;

static void DrawMsg(char *msg, short rlen)
{
    static short nl = 0;
    if(nl)
    {
        io_sbyte(ChanId, -1, '\n');
    }
    nl = 1;
    io_sstrg(ChanId, -1, (char *)msg, rlen);
}
static void Reader(void)
{
#ifndef TEST
    extern short __returnCSP__ ;

    int ctx;
    char *msg;
    short rlen;
       
    __returnCSP__ = 1;
    ctx = UseSrvThg(LSTN, "QFAX");
    __returnCSP__ = 0;

    if( ctx > 0)
    {
        repchn = *((int *) ctx +  7);
        while (LstnPoll("QFAX", -1, &msg, &rlen) >= 0)
        {
            /*
             * A little hack to avoid "pending newline" screwups
             * when ADRAW is invoked by the parent task.
             */
            DrawMsg(msg, rlen);
            free(msg);
        }
    }
#endif
}

static long ACMD (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    return PT__DO;
}

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    wm_swdef (wwk, apw, ChanId);
    return 0;
}

static long MMOVE (struct WM_wwork *wwk, struct WM_litm *li)
{
    short dx, dy;
    struct QLRECT rct;

    sd_pxenq(ChanId, -1, &rct);
    wwk->wstat->evnt |= PT_WMOVE;
    wm_chwin (wwk, &dx, &dy);
    ADRAW (wwk, (struct WM_appw *) &aw0);
    sd_pixp(ChanId, -1, rct.q_x, rct.q_y); 
    return lit_reset (wwk, li->item);
}

static char Host[64] = "QFAX";
static char prefix[32] = {0};

static void ActionCmd(struct WM_wwork *wwk)
{
    int rc;
    QD_TEXT(80) cmd;
    short rlen;
    char *p;
    char txt[120];
    
    wm_swinf (wwk, 2, 0);
    sd_pixp (wwk->chid, -1, 0, 1);
    sd_clrrt (wwk->chid, -1);
    cmd.len = 0;
    rc = wm_rname(wwk->chid, (struct QD_text *) &cmd);

    if(rc == 0 && cmd.len && cmd.chrs[0] != 10)
    {
        *(cmd.chrs+cmd.len) = 0;
        p = stpcpy(txt, prefix);
        strncpy(p, (char *) cmd.chrs, cmd.len);   
        rlen = cmd.len + (p - txt);
        
        if(p = Request(Host, txt, rlen, &rlen))
        {
            if(repchn)
            {
                char *tmp = malloc(rlen + 6);
                *(long *) tmp = 0;
                *(short *) (tmp + 4) = rlen;
                memcpy(tmp+6, p, rlen);
                io_sstrg(repchn, 0, tmp, rlen+6);
                free(tmp);
            }
            else
            {
                DrawMsg(p, rlen); 
            }
            free(p);
        }
    }
}

int main (int ac, char **av)
{
    int n;
    char *sp;
    short nc;
    short mlen;
    char *msg;

    mt_prior(-1, 1);
    
    sp = *(av + 1);		// supplied sp
    nc = *((short *) sp)++;	// channels
    sp += (nc << 2);		// skip channels
    mlen = *((short *) sp)++;	// commands
    if (mlen)			// need this too
    {
        char *p = prefix;
        stpcpy(Host, "CSMNet");
#ifdef TEST
        if(*sp == 'm')
        {
            *(Host+6) = '1';
            *(Host+7) = 0;
            mlen = 1;
            *sp = '2';
        }
#endif
        *p++ = 'n';
        while(mlen--)
        {
            if(*sp >= '0' && *sp <= '9')
            {
                *p++ = *sp;
            }
            sp++;
        }
        *p++ = '_';
        *p++ = 'Q';        
        *p++ = 'F';        
        *p++ = 'A';        
        *p++ = 'X';        
        *p++ = ' ';
        *p = 0;        
    }
    ww.chid = io_open ("con", 0);
    if (wm_findv (ww.chid))
    {
        if((n = UseSrvThg(CLNT, Host)) >= 0)
        {
            ChanId = io_open ("scr", 0);
            ws.wwork = &ww;

            wm_prpos (&ww, -1, -1);
            wm_wdraw (&ww);

            wm_swinf (&ww, 2, -1);
            sd_setpa (ww.chid, -1, 7);
            sd_setst (ww.chid, -1, 7);

            pid = jcall (Reader, "qfax Listener", 1, 2048, 0);
            while(wm_rptr(&ww) == 0)
            {
	        if (ws.evnt & PT_DO)
	        {
	            ActionCmd(&ww);
                }
    	        if (ws.evnt & PT_CAN)
	        {
	            break;
	        }
            }    
	    FreeSrvThg (CLNT, Host);
            wm_cluns (&ww);
        }
    }
    else
    {
        n = -21;
    }
    return n;
}
int (*_Cstart) (int, char **) = main;
