
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "qheader.h"


main(int ac, char **av)
{
    FILE *f, *g;
    unsigned char swap_table[256];
    QFAXHEADER h;
    int i;
        
    if(ac != 3)
    {
        puts("Wrong No. arguments");
        exit(0);
    }

    if((f = fopen(av[1], "r")) == NULL)
    {
        puts("Can't open input file");
        exit(0);
    }

    if((g = fopen(av[2], "w")) == NULL)
    {
        puts("Can't open output file");
        exit(0);
    }

    for (i = 0; i < 256; i++)
	swap_table[i] =
	    (i & 1 ? 128 : 0) | (i & 2 ? 64 : 0) | (i & 4 ? 32 : 0) | (i & 8 ? 16 : 0) |
	    (i & 16 ? 8 : 0) | (i & 32 ? 4 : 0) | (i & 64 ? 2 : 0) | (i & 128 ? 1 : 0);
    

    fread (&h, 1, QFAXHEADLEN, f);

    if (h.title != QFAXTITLE)
    {
	fputs ("Not QFAX", stderr);
	exit (3);
    }

    fwrite (&h, 1, QFAXHEADLEN, g);

    while((i = fgetc(f)) != EOF)
    {
        fputc(swap_table[i], g);
    }

    fclose(f);
    fclose(g);
    
    return 0;
}

